//This originally came from an article 'Compile-time primes' by "Harmen Stoppels"
//Putting the count_primes vector in place of the original constexpr, it still runs.
//The CoPrime (GCD) segment added, isn't compile time, but indicates that this could be
//a programming design for such as Elliptics and Bundles for determining Crank Combinatrics.
//Would a Truple and Euclidean vector Z make this compile time ???? At least Quantum.
//gcd(a,b) = 1 -> a,b coprime

#include <iostream>
#include <vector>
template<size_t P, size_t N, typename T> T count_primes(const std::vector<T>& values)
{
    size_t total = 0;
    size_t CoPrime = 0;
    bool is_prime[N]{};

    for (auto& value : values) {
        CoPrime = value;
        size_t CoPrime2 = P;
        while (CoPrime2 != (CoPrime == 0)) {
            CoPrime = CoPrime % CoPrime2;
            std::swap(CoPrime, CoPrime2);
           
        }
        std::cout << "Greatest Common Denominator " << CoPrime << std::endl;
      int sum1 = (value - P);
        std::cout << "a is congruent to b modulo m, So a - b = " << abs(sum1) << std::endl;
    }

    // Assume all numbers are prime. 
    for (size_t n = 0; n < N; ++n)
        is_prime[n] = true;

    // Sieve primes starting at 2.
    for (size_t n = 2; n * n < N; ++n)
        if (is_prime[n])
            for (size_t multiple = n * n; multiple < N; multiple += n)
                is_prime[multiple] = false;

    // Count primes.
    for (size_t n = 2; n < N; ++n)
        if (is_prime[n])
            ++total;

    return total;
}

int main()
{
    std::vector<double>VectorData{ 7,23,37,67,265,79,190,271,277,300 };
    std::cout << "Count Primes (range = 100) " << count_primes<271,100>(VectorData) << std::endl;
    std::cout << "Count Primes (range = 300) " << count_primes<271,300>(VectorData) << std::endl;
 
}